
open Gram

type 's action = 
  | Success
  | Shift of 's
  | Reduce of rule

exception Error

type 's automaton = {
  start: 's * non_terminal;
  actions: 's -> terminal -> 's action;
  gotos: 's -> non_terminal -> 's;
}
  
val run : 's automaton -> terminal list -> unit

