
(* Pretty-print of tables. *)

module type TypeWithPrinter = sig
  type t
  val pp : t -> string
end

module type S = sig
  type t
  val pp_table : t -> unit
  val pp_latex_table : t -> string -> unit
end

module Make
  (A : TypeWithPrinter)
  (B : TypeWithPrinter)
  (C : TypeWithPrinter)
  (Amap : Map.S with type key = A.t)
  (Bmap : Map.S with type key = B.t) = struct

    type t = C.t Bmap.t Amap.t
    
    let pp_table t = failwith "todo"
(***
      let columns = 
      printf "    "; Tset.iter (printf "| %3s ") all_t;
  printf "\n";
  let pp_line nt =
    let m = Ntmap.find nt t in
    printf "%3s " nt;
    Tset.iter 
      (fun t -> printf "| %3s " (try let _ = Tmap.find t m in "E" with Not_found -> "")) 
      all_t;
    printf "\n"
  in
  Ntset.iter pp_line all_nt;
  flush stdout
***)

    let pp_latex_table t = failwith "pp_latex_table: todo"

  end
