
(*s Fixpoint computation. *)

let rec fixpoint f x0 =
  let (x1,isnew) = f x0 in 
  if isnew then fixpoint f x1 else x1

(* Pretty-print *)

open Format

let rec pp_list f sep fmt = function
  | [] -> ()
  | [x] -> f fmt x
  | x :: l -> f fmt x; sep fmt (); pp_list f sep fmt l

let space fmt () = fprintf fmt "@ "
let comma fmt () = fprintf fmt ",@ "
let newline fmt () = fprintf fmt "@\n"
