
(*s Fixpoint computation. The boolean indicates whether another iteration
    is necessary. *)

val fixpoint : ('a -> 'a * bool) -> 'a -> 'a

(*s Pretty-print *)

open Format

val pp_list :
  (formatter -> 'b -> unit) -> 
  (formatter -> unit -> unit) -> 
  formatter -> 'b list -> unit

val space : formatter -> unit -> unit
val comma : formatter -> unit -> unit
val newline : formatter -> unit -> unit
